/* EEL4744C Fall 2002
/* Converts S1 (2 byte addr) records into S3 (4 byte addr) records */
/* Offsets from $0000 to $8000 */
/* John A. Martiney, TA */

#include <stdio.h>
#include <stdlib.h>

int main(int argc, char *argv[])
{
  char *progname;		//Used to get program name
  char *filein;			//Used to get input S3 file
  char *fileout;		//Used to produce output S1 file
  FILE *fileinptr;		//Input file pointer
  FILE *fileoutptr;		//Output file pointer
  char charsin[] = {1,1}; 	//Input character array
  unsigned int hexin = 0xAA;	//Used for hex input
  unsigned int hexin2 = 0xAA;   //Used for other hex input
  unsigned int hexin3 = 0xAA;   //Used for address hex input
  unsigned int is_end = 1;      //Used for end of file
  unsigned int chk_sum = 0;     //Used for calculating checksum
  unsigned int offset = 0;	//Used to give memory offset

  progname = *argv++;		//Get program name
  filein = *argv++;		//Get input filename
  fileout = *argv++;		//Get output filename
  offset = atoi(*argv++);	//Get address offset

  fileinptr = fopen(filein,"r");	//Open input for reading
  fileoutptr = fopen(fileout,"w");	//Open output for writing

  while(is_end != EOF)
  {
    is_end = fscanf(fileinptr,"%2s",&charsin);	

    if(charsin[0] == 'S' && charsin[1] == '0')
    {
      printf("Ignored S0 header record\n");
    }

    else if(charsin[0] == 'S' && charsin[1] == '1')
    {
      charsin[0] = 'S';
      charsin[1] = '3';
      fprintf(fileoutptr,"%2s",charsin);
      is_end = fscanf(fileinptr,"%2x",&hexin);
      hexin--;			//ignore the upper 2 bytes
      hexin--;			//in the 4-byte address
      is_end = fscanf(fileinptr,"%2x",&hexin2);
      is_end = fscanf(fileinptr,"%2x",&hexin2);
      
      fprintf(fileoutptr,"%.2x",hexin);

      chk_sum = hexin;		//start of check_sum
      
      is_end = fscanf(fileinptr,"%4x",&hexin2);
      hexin2 = hexin2 + offset;
      hexin3 = hexin2;
      fprintf(fileoutptr,"%.4x",hexin2);
      
      hexin2 = hexin2 & 0x00FF;
      chk_sum = chk_sum + hexin2;

      hexin3 = hexin3 >> 8;
      hexin3 = hexin3 & 0x00FF;
      chk_sum = chk_sum + hexin3;

      hexin--;			//Decrement due to the address
      hexin--;

      for(hexin;hexin > 1;hexin--)
      {
        is_end = fscanf(fileinptr,"%2x",&hexin2);
	fprintf(fileoutptr,"%.2x",hexin2);
	chk_sum = chk_sum + hexin2;
      }
  
      chk_sum = 255 - chk_sum;	//the 1's complement
      chk_sum = chk_sum & 0x00FF;	//keep the lower byte
      fprintf(fileoutptr,"%.2x",chk_sum);

      fprintf(fileoutptr,"\n");		//mark the end of an s-record
    }
  }

  fprintf(fileoutptr,"S903FFFFFE\n");   //S9 record to indicate end

  fclose(fileinptr);		//Close input file
  fclose(fileoutptr);		//Close output file
  return 0;			//End of main
}
